<?xml version="1.0" encoding="utf-8"?>
<xbrl
  xml:lang="en-US"
  xmlns="http://www.xbrl.org/2003/instance"
  xmlns:dei="http://xbrl.sec.gov/dei/2020-01-31"
  xmlns:link="http://www.xbrl.org/2003/linkbase"
  xmlns:xlink="http://www.w3.org/1999/xlink">
    <link:schemaRef xlink:href="bokf-20210721.xsd" xlink:type="simple"/>
    <context id="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721">
        <entity>
            <identifier scheme="http://www.sec.gov/CIK">0000875357</identifier>
        </entity>
        <period>
            <startDate>2021-07-21</startDate>
            <endDate>2021-07-21</endDate>
        </period>
    </context>
    <dei:EntityCentralIndexKey
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl80L2ZyYWc6NjE1OGY0OGJhY2UwNGZhNDg1NWIzNjgzMzExZTE2ZmIvdGFibGU6NTIxM2JlMDI5YjYxNGQ0MWJiNmNhMjI0OGYwYThmZTgvdGFibGVyYW5nZTo1MjEzYmUwMjliNjE0ZDQxYmI2Y2EyMjQ4ZjBhOGZlOF8yLTEtMS0xLTA_b9ce56c8-b8f4-4100-b761-bb7b473b22af">0000875357</dei:EntityCentralIndexKey>
    <dei:AmendmentFlag
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl80L2ZyYWc6NjE1OGY0OGJhY2UwNGZhNDg1NWIzNjgzMzExZTE2ZmIvdGFibGU6NTIxM2JlMDI5YjYxNGQ0MWJiNmNhMjI0OGYwYThmZTgvdGFibGVyYW5nZTo1MjEzYmUwMjliNjE0ZDQxYmI2Y2EyMjQ4ZjBhOGZlOF81LTEtMS0xLTA_5429e693-49ba-46c0-9cd2-6376406dacbb">false</dei:AmendmentFlag>
    <dei:DocumentType
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzc4_2479ce86-806a-4762-afeb-f1858246ad05">8-K</dei:DocumentType>
    <dei:DocumentPeriodEndDate
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yMzI_985e9e74-5f38-4f90-9c41-583dc2762af8">2021-07-21</dei:DocumentPeriodEndDate>
    <dei:EntityFileNumber
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzcy_da27550d-8e47-4152-a570-b1d260c92f76">0-19341</dei:EntityFileNumber>
    <dei:EntityRegistrantName
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzcz_dc206cf3-3db2-43f7-827a-32cb46eb1f31">BOK FINANCIAL CORP ET AL</dei:EntityRegistrantName>
    <dei:EntityIncorporationStateCountryCode
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGFibGU6OWZkMGQ0MTQ1ODczNGFiNWE1ZmY4MTNmN2Q0N2NmMmMvdGFibGVyYW5nZTo5ZmQwZDQxNDU4NzM0YWI1YTVmZjgxM2Y3ZDQ3Y2YyY18wLTAtMS0xLTA_a87b29ec-a719-49ba-b913-c4df0077baff">OK</dei:EntityIncorporationStateCountryCode>
    <dei:EntityTaxIdentificationNumber
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGFibGU6OWZkMGQ0MTQ1ODczNGFiNWE1ZmY4MTNmN2Q0N2NmMmMvdGFibGVyYW5nZTo5ZmQwZDQxNDU4NzM0YWI1YTVmZjgxM2Y3ZDQ3Y2YyY18wLTMtMS0xLTA_6c6fba19-6930-4bdd-88fe-bfec7a0c85c3">73-1373454</dei:EntityTaxIdentificationNumber>
    <dei:EntityAddressAddressLine1
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGFibGU6OWZkMGQ0MTQ1ODczNGFiNWE1ZmY4MTNmN2Q0N2NmMmMvdGFibGVyYW5nZTo5ZmQwZDQxNDU4NzM0YWI1YTVmZjgxM2Y3ZDQ3Y2YyY180LTAtMS0xLTA_1c8b233d-4cc2-4fe8-ae4c-f5603dd8a2a9">Boston Avenue at Second Street</dei:EntityAddressAddressLine1>
    <dei:EntityAddressCityOrTown
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGFibGU6OWZkMGQ0MTQ1ODczNGFiNWE1ZmY4MTNmN2Q0N2NmMmMvdGFibGVyYW5nZTo5ZmQwZDQxNDU4NzM0YWI1YTVmZjgxM2Y3ZDQ3Y2YyY181LTAtMS0xLTA_9ffbc60f-ac36-492f-9c5d-7d117a3faf62">Tulsa,</dei:EntityAddressCityOrTown>
    <dei:EntityAddressStateOrProvince
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGFibGU6OWZkMGQ0MTQ1ODczNGFiNWE1ZmY4MTNmN2Q0N2NmMmMvdGFibGVyYW5nZTo5ZmQwZDQxNDU4NzM0YWI1YTVmZjgxM2Y3ZDQ3Y2YyY181LTEtMS0xLTA_55a24509-07ca-4622-a2af-e9807d93a089">OK</dei:EntityAddressStateOrProvince>
    <dei:EntityAddressPostalZipCode
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGFibGU6OWZkMGQ0MTQ1ODczNGFiNWE1ZmY4MTNmN2Q0N2NmMmMvdGFibGVyYW5nZTo5ZmQwZDQxNDU4NzM0YWI1YTVmZjgxM2Y3ZDQ3Y2YyY181LTMtMS0xLTA_6580bb64-db1d-463f-9755-b03381a0f7d5">74192</dei:EntityAddressPostalZipCode>
    <dei:CityAreaCode
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzc5_b616c460-2e11-420a-a3f4-23b4486c6230">918</dei:CityAreaCode>
    <dei:LocalPhoneNumber
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzc0_4d77bf90-4709-43d1-8722-df2c297ec057">588-6000</dei:LocalPhoneNumber>
    <dei:WrittenCommunications
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzcx_7ab6f317-6d4c-49d6-b8d3-f1ac348e7bc5">false</dei:WrittenCommunications>
    <dei:SolicitingMaterial
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzgw_90b734b2-4168-4118-abfd-dcb8fbc4ed36">false</dei:SolicitingMaterial>
    <dei:PreCommencementTenderOffer
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzc1_664e30f1-140b-443f-8f84-66847d72c655">false</dei:PreCommencementTenderOffer>
    <dei:PreCommencementIssuerTenderOffer
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzc2_2c8bfaeb-e72a-43d8-9e12-47f7e588f615">false</dei:PreCommencementIssuerTenderOffer>
    <dei:EntityEmergingGrowthCompany
      contextRef="ic2e27cb9c29547ada2ff6ea14bd29fa4_D20210721-20210721"
      id="id3VybDovL2RvY3MudjEvZG9jOjNlMGNlNTRlYjFhMDQ5MmU4NjZmYjBlYmQ5NjM5MzFmL3NlYzozZTBjZTU0ZWIxYTA0OTJlODY2ZmIwZWJkOTYzOTMxZl8xL2ZyYWc6N2IzNWUyODE5YzkwNDgyNThjZWRhNzgzM2VhNWFjZTUvdGV4dHJlZ2lvbjo3YjM1ZTI4MTljOTA0ODI1OGNlZGE3ODMzZWE1YWNlNV8yNzc3_cc62acc1-0a1a-4d53-a97f-bb942ee81247">false</dei:EntityEmergingGrowthCompany>
</xbrl>
